################################################################################
######### Hub Model without Null Component
######### Table 3
################################################################################
tbl3set = function(scenario){
  if (scenario == 1) {n0 = 10; T = 1000; n = 100; M = 80}
  if (scenario == 2) {n0 = 10; T = 1000; n = 500; M = 80}
  if (scenario == 3) {n0 = 10; T = 1000; n = 500; M = 200}
  if (scenario == 4) {n0 = 10; T = 1000; n = 500; M = 300}
  if (scenario == 5) {n0 = 20; T = 1000; n = 100; M = 80}
  if (scenario == 6) {n0 = 20; T = 1000; n = 500; M = 80}
  if (scenario == 7) {n0 = 20; T = 1000; n = 500; M = 200}
  if (scenario == 8) {n0 = 20; T = 1000; n = 500; M = 300}
  if (scenario == 9) {n0 = 10; T = 2000; n = 100; M = 80}
  if (scenario == 10) {n0 = 10; T = 2000; n = 500; M = 80}
  if (scenario == 11) {n0 = 10; T = 2000; n = 500; M = 200}
  if (scenario == 12) {n0 = 10; T = 2000; n = 500; M = 300}
  if (scenario == 13) {n0 = 20; T = 1000; n = 100; M = 80}
  if (scenario == 14) {n0 = 20; T = 1000; n = 500; M = 80}
  if (scenario == 15) {n0 = 20; T = 1000; n = 500; M = 200}
  if (scenario == 16) {n0 = 20; T = 1000; n = 500; M = 300}
  return(c(n0 = n0, T = T, n = n, M = M))
}
## delete the scenario in which M  = 200 or 300 -----
##
GenA = function(n,n0,pi,alpha){
  A = matrix(NA,n0,n)
  A_lab = vector("list",n0)
  # set of followers except hub itself
  for(i in 1:n0) A_lab[[i]] = seq(n0+i,n,n0)
  for(i in 1:n0){
    A[i,A_lab[[i]]] = runif(length(A_lab[[i]]),0.2,0.4)*alpha
    A[i,-A_lab[[i]]] = runif(n-length(A_lab[[i]]),0,0.2)*alpha
  }
  diag(A) = 1
  return(rbind(pi*alpha,A))
}
##
GenG = function(A,T,rho){
  n0=dim(A)[1]; n=dim(A)[2]
  G = matrix(0,T,n)
  hub = rep(NA,T)
  for(t in 1:T){
    hub[t] = sample(1:n0,1,prob=rho)
    G[t,]=rbinom(n,1,prob=A[hub[t],])
  }
  return(G)
}
##
bic.sele = function(i,lam){
  rho0 = c(0.2,runif(n0,min=0.8/(2*n0),max=0.8*2/n0))
  pi0 = rep(0.05,n)
  A0 = GenA(n,n0,pi0,alpha=1)
  G0 = GenG(A0,T,rho0)
  # initial A
  A = matrix(NA,M,n)
  for(i in 1:M)A[i,] = colSums(G0[,i]*G0)/sum(G0[,i])
  diag(A) = 1; A = rbind(runif(n),A)
  # initial rho
  rho = c(0.2,rep(0.8/M,M))
  model = lapply(lam,phub,G=G0,A=A,rho=rho,pen.type="plog")
  sel = matrix(NA,length(lam),(M+1))
  bbic = baic = rep(NA,length(lam))
  bic = function(x,hatM) x-0.5*log(T)*(n+1)*hatM # BIC criteria
  aic = function(x,hatM) x-(n+1)*hatM # AIC criteria
  for(i in 1:length(lam)){
    sel[i,] = model[[i]]$rho
    tc = sum(model[[i]]$rho!=0)
    bbic[i] = bic(model[[i]]$l,tc)
    baic[i] = aic(model[[i]]$l,tc)
  }
  out = cbind(lam,bbic,baic,sel)
  colnames(out) = c("lambda","bic","aic",paste("rho",0:M,sep=""))
  return(out)
} 
####
phub.model = function(Iter = 10){
  lam = seq(0.008,0.018,0.001)
  out = lapply(1:Iter, bic.sele, lam = lam)
  # remove NAN
  f = function(x,col) {
    ind = ifelse(length(which.max(x[,col]))==0,NA,which.max(x[,col]))
    if(is.na(ind)) NULL
    else x[ind,-c(1,2,3)]
  }
  temp.aic = do.call(rbind,lapply(out,f,col=3)) # keep rho0--rhoM
  temp.bic = do.call(rbind,lapply(out,f,col=2))
  ftpr = function(x){
    tp = sum(which(x!=0) %in% c(2:(n0+1)))
    fp = sum(x!=0) - tp -1
    tpr = tp/n0
    fpr = fp/M
    return(c(tpr,fpr))
  }
  xx = rbind(rowMeans(apply(temp.aic,1,ftpr)),rowMeans(apply(temp.bic,1,ftpr)))
  colnames(xx) = c("TPR","FPR")
  return(xx)
}

## combine to One Table
tbl3.simu = function(Iter = 10){
  cl = parallel::makeCluster(6)
  doParallel::registerDoParallel(cl)
  out = foreach::foreach(scenario = 1:16,
                         .export = c("GenA","GenG","phub","tbl3set","bic.sele","phub.model"),.errorhandling="pass") %dopar% {
                           temp = tbl3set(scenario)
                           n0 = as.numeric(temp[1])
                           T = as.numeric(temp[2])
                           n = as.numeric(temp[3])
                           M = as.numeric(temp[4])
                           phub.model(Iter = Iter)             
                         }
  parallel::stopCluster(cl)
  return(out)
}

